/* This file was generated by SableCC (http://www.sablecc.org/). */

package MONAViewer.monalanguage.lexer;

import java.io.*;
import java.util.*;
import MONAViewer.monalanguage.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                BufferedReader r = new BufferedReader (new InputStreamReader (
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = Integer.parseInt(r.readLine());
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = Integer.parseInt(r.readLine());
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = Integer.parseInt(r.readLine());
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = Integer.parseInt(r.readLine());
                            }
                        }
                    }
                }

                // read accept
                length = Integer.parseInt(r.readLine());
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = Integer.parseInt(r.readLine());
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = Integer.parseInt(r.readLine());
                    }
                }

                r.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);
                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            Token token = new85(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            Token token = new86(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TIgnored(text, line, pos); }
    Token new1(int line, int pos) { return new TAll0(line, pos); }
    Token new2(int line, int pos) { return new TAll1(line, pos); }
    Token new3(int line, int pos) { return new TAll2(line, pos); }
    Token new4(int line, int pos) { return new TAnd(line, pos); }
    Token new5(int line, int pos) { return new TArrow(line, pos); }
    Token new6(int line, int pos) { return new TAssert(line, pos); }
    Token new7(int line, int pos) { return new TBiimpl(line, pos); }
    Token new8(int line, int pos) { return new TColon(line, pos); }
    Token new9(int line, int pos) { return new TComma(line, pos); }
    Token new10(int line, int pos) { return new TConst(line, pos); }
    Token new11(int line, int pos) { return new TDefault1(line, pos); }
    Token new12(int line, int pos) { return new TDefault2(line, pos); }
    Token new13(int line, int pos) { return new TDot(line, pos); }
    Token new14(int line, int pos) { return new TEmpty(line, pos); }
    Token new15(int line, int pos) { return new TEqual(line, pos); }
    Token new16(int line, int pos) { return new TEx0(line, pos); }
    Token new17(int line, int pos) { return new TEx1(line, pos); }
    Token new18(int line, int pos) { return new TEx2(line, pos); }
    Token new19(int line, int pos) { return new TFalse(line, pos); }
    Token new20(int line, int pos) { return new TGreater(line, pos); }
    Token new21(int line, int pos) { return new TGreatereq(line, pos); }
    Token new22(int line, int pos) { return new TGuide(line, pos); }
    Token new23(int line, int pos) { return new TImpl(line, pos); }
    Token new24(int line, int pos) { return new TIn(line, pos); }
    Token new25(int line, int pos) { return new TInter(line, pos); }
    Token new26(int line, int pos) { return new TInterval(line, pos); }
    Token new27(int line, int pos) { return new TLbrace(line, pos); }
    Token new28(int line, int pos) { return new TLbracket(line, pos); }
    Token new29(int line, int pos) { return new TLess(line, pos); }
    Token new30(int line, int pos) { return new TLesseq(line, pos); }
    Token new31(int line, int pos) { return new TLet0(line, pos); }
    Token new32(int line, int pos) { return new TLet1(line, pos); }
    Token new33(int line, int pos) { return new TLet2(line, pos); }
    Token new34(int line, int pos) { return new TLparen(line, pos); }
    Token new35(int line, int pos) { return new TMacro(line, pos); }
    Token new36(int line, int pos) { return new TMax(line, pos); }
    Token new37(int line, int pos) { return new TMin(line, pos); }
    Token new38(int line, int pos) { return new TMinus(line, pos); }
    Token new39(int line, int pos) { return new TModulo(line, pos); }
    Token new40(int line, int pos) { return new TNot(line, pos); }
    Token new41(int line, int pos) { return new TNotequal(line, pos); }
    Token new42(int line, int pos) { return new TNotin(line, pos); }
    Token new43(int line, int pos) { return new TOr(line, pos); }
    Token new44(int line, int pos) { return new TPlus(line, pos); }
    Token new45(int line, int pos) { return new TPred(line, pos); }
    Token new46(int line, int pos) { return new TRbrace(line, pos); }
    Token new47(int line, int pos) { return new TRestrict(line, pos); }
    Token new48(int line, int pos) { return new TRbracket(line, pos); }
    Token new49(int line, int pos) { return new TUnivroot(line, pos); }
    Token new50(int line, int pos) { return new TRparen(line, pos); }
    Token new51(int line, int pos) { return new TSemicolon(line, pos); }
    Token new52(int line, int pos) { return new TSetminus(line, pos); }
    Token new53(int line, int pos) { return new TSlash(line, pos); }
    Token new54(int line, int pos) { return new TStar(line, pos); }
    Token new55(int line, int pos) { return new TVerify(line, pos); }
    Token new56(int line, int pos) { return new TSub(line, pos); }
    Token new57(int line, int pos) { return new TTree(line, pos); }
    Token new58(int line, int pos) { return new TTrue(line, pos); }
    Token new59(int line, int pos) { return new TUnion(line, pos); }
    Token new60(int line, int pos) { return new TUniverse(line, pos); }
    Token new61(int line, int pos) { return new TUp(line, pos); }
    Token new62(int line, int pos) { return new TVar0(line, pos); }
    Token new63(int line, int pos) { return new TVar1(line, pos); }
    Token new64(int line, int pos) { return new TVar2(line, pos); }
    Token new65(int line, int pos) { return new TWhere(line, pos); }
    Token new66(int line, int pos) { return new TInclude(line, pos); }
    Token new67(int line, int pos) { return new TImport(line, pos); }
    Token new68(int line, int pos) { return new TExport(line, pos); }
    Token new69(int line, int pos) { return new TPrefix(line, pos); }
    Token new70(int line, int pos) { return new TM2lstr(line, pos); }
    Token new71(int line, int pos) { return new TM2ltree(line, pos); }
    Token new72(int line, int pos) { return new TLastpos(line, pos); }
    Token new73(int line, int pos) { return new TInstatespace(line, pos); }
    Token new74(int line, int pos) { return new TExecute(line, pos); }
    Token new75(int line, int pos) { return new TType(line, pos); }
    Token new76(int line, int pos) { return new TSometype(line, pos); }
    Token new77(int line, int pos) { return new TVariant(line, pos); }
    Token new78(int line, int pos) { return new TSucc(line, pos); }
    Token new79(int line, int pos) { return new TWs1s(line, pos); }
    Token new80(int line, int pos) { return new TWs2s(line, pos); }
    Token new81(int line, int pos) { return new TTreeroot(line, pos); }
    Token new82(int line, int pos) { return new TConsttree(line, pos); }
    Token new83(int line, int pos) { return new TAllpos(line, pos); }
    Token new84(String text, int line, int pos) { return new TInt(text, line, pos); }
    Token new85(String text, int line, int pos) { return new TName(text, line, pos); }
    Token new86(String text, int line, int pos) { return new TString(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }


    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable; /* = {
      {
        {
          {9, 9, 1},
          {10, 10, 2},
          {13, 13, 3},
          {32, 32, 4},
          {34, 34, 5},
          {35, 35, 6},
          {36, 36, 7},
          {38, 38, 8},
          {40, 40, 9},
          {41, 41, 10},
          {42, 42, 11},
          {43, 43, 12},
          {44, 44, 13},
          {45, 45, 14},
          {46, 46, 15},
          {47, 47, 16},
          {48, 48, 17},
          {49, 57, 18},
          {58, 58, 19},
          {59, 59, 20},
          {60, 60, 21},
          {61, 61, 22},
          {62, 62, 23},
          {65, 90, 24},
          {91, 91, 25},
          {92, 92, 26},
          {93, 93, 27},
          {94, 94, 28},
          {95, 95, 29},
          {97, 97, 30},
          {98, 98, 31},
          {99, 99, 32},
          {100, 100, 33},
          {101, 101, 34},
          {102, 102, 35},
          {103, 103, 36},
          {104, 104, 31},
          {105, 105, 37},
          {106, 107, 31},
          {108, 108, 38},
          {109, 109, 39},
          {110, 110, 40},
          {111, 111, 31},
          {112, 112, 41},
          {113, 113, 31},
          {114, 114, 42},
          {115, 115, 43},
          {116, 116, 44},
          {117, 117, 45},
          {118, 118, 46},
          {119, 119, 47},
          {120, 122, 31},
          {123, 123, 48},
          {124, 124, 49},
          {125, 125, 50},
          {126, 126, 51},
        },
        {
          {9, 32, -2},
          {35, 35, 6},
          {47, 47, 52},
        },
        {
          {9, 47, -3},
        },
        {
          {9, 47, -3},
        },
        {
          {9, 47, -3},
        },
        {
          {0, 33, 53},
          {34, 34, 54},
          {35, 91, 53},
          {93, 65535, 53},
        },
        {
          {0, 8, 55},
          {9, 9, 56},
          {10, 10, 2},
          {11, 12, 55},
          {13, 13, 3},
          {14, 31, 55},
          {32, 32, 57},
          {33, 34, 55},
          {35, 35, 58},
          {36, 46, 55},
          {47, 47, 59},
          {48, 65535, 55},
        },
        {
          {36, 36, 60},
          {39, 39, 61},
          {48, 57, 62},
          {65, 90, 63},
          {95, 95, 64},
          {97, 122, 65},
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
          {62, 62, 66},
        },
        {
          {46, 46, 67},
        },
        {
          {42, 42, 68},
        },
        {
        },
        {
          {48, 57, 69},
        },
        {
        },
        {
        },
        {
          {61, 61, 70},
        },
        {
          {62, 62, 71},
        },
        {
          {61, 61, 72},
        },
        {
          {36, 122, -9},
        },
        {
        },
        {
        },
        {
        },
        {
        },
        {
          {36, 122, -9},
        },
        {
          {36, 95, -9},
          {97, 107, 65},
          {108, 108, 73},
          {109, 114, 65},
          {115, 115, 74},
          {116, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 95, -9},
          {97, 110, 65},
          {111, 111, 75},
          {112, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 100, 65},
          {101, 101, 76},
          {102, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 108, 65},
          {109, 109, 77},
          {110, 119, 65},
          {120, 120, 78},
          {121, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 79},
          {98, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 116, 65},
          {117, 117, 80},
          {118, 122, 65},
        },
        {
          {36, 108, -36},
          {109, 109, 81},
          {110, 110, 82},
          {111, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 83},
          {98, 100, 65},
          {101, 101, 84},
          {102, 122, 65},
        },
        {
          {36, 39, -9},
          {48, 49, 62},
          {50, 50, 85},
          {51, 57, 62},
          {65, 95, -9},
          {97, 97, 86},
          {98, 104, 65},
          {105, 105, 87},
          {106, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 88},
          {112, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 113, 65},
          {114, 114, 89},
          {115, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 90},
          {102, 110, 65},
          {111, 111, 91},
          {112, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 92},
          {112, 116, 65},
          {117, 117, 93},
          {118, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 94},
          {115, 120, 65},
          {121, 121, 95},
          {122, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 109, 65},
          {110, 110, 96},
          {111, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 97},
          {98, 100, 65},
          {101, 101, 98},
          {102, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 103, 65},
          {104, 104, 99},
          {105, 114, 65},
          {115, 115, 100},
          {116, 122, 65},
        },
        {
        },
        {
        },
        {
        },
        {
          {61, 61, 101},
        },
        {
          {42, 42, 68},
        },
        {
          {0, 65535, -7},
        },
        {
        },
        {
          {0, 65535, -8},
        },
        {
          {0, 65535, -8},
        },
        {
          {0, 65535, -8},
        },
        {
          {0, 65535, -8},
        },
        {
          {0, 35, -8},
          {36, 41, 55},
          {42, 42, 102},
          {43, 46, 55},
          {47, 65535, -8},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
        },
        {
          {46, 46, 103},
        },
        {
          {0, 41, 104},
          {42, 42, 105},
          {43, 65535, 104},
        },
        {
          {48, 57, 69},
        },
        {
          {62, 62, 106},
        },
        {
        },
        {
        },
        {
          {36, 107, -32},
          {108, 108, 107},
          {109, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 114, 65},
          {115, 115, 108},
          {116, 122, 65},
        },
        {
          {36, 109, -47},
          {110, 110, 109},
          {111, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 101, 65},
          {102, 102, 110},
          {103, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 111, 65},
          {112, 112, 111},
          {113, 122, 65},
        },
        {
          {36, 39, -9},
          {48, 48, 112},
          {49, 49, 113},
          {50, 50, 114},
          {51, 95, -41},
          {97, 100, 65},
          {101, 101, 115},
          {102, 111, 65},
          {112, 112, 116},
          {113, 122, 65},
        },
        {
          {36, 107, -32},
          {108, 108, 117},
          {109, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 104, 65},
          {105, 105, 118},
          {106, 122, 65},
        },
        {
          {36, 111, -79},
          {112, 112, 119},
          {113, 122, 65},
        },
        {
          {36, 90, -9},
          {95, 95, 120},
          {97, 98, 65},
          {99, 99, 121},
          {100, 115, 65},
          {116, 116, 122},
          {117, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 123},
          {116, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 115, 65},
          {116, 116, 124},
          {117, 122, 65},
        },
        {
          {36, 107, -32},
          {108, 108, 125},
          {109, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 98, 65},
          {99, 99, 126},
          {100, 119, 65},
          {120, 120, 127},
          {121, 122, 65},
        },
        {
          {36, 109, -47},
          {110, 110, 128},
          {111, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 129},
          {117, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 130},
          {102, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 131},
          {116, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 132},
          {112, 122, 65},
        },
        {
          {36, 108, -36},
          {109, 109, 133},
          {110, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 65},
          {98, 98, 134},
          {99, 99, 135},
          {100, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 136},
          {102, 116, 65},
          {117, 117, 137},
          {118, 122, 65},
        },
        {
          {36, 111, -79},
          {112, 112, 138},
          {113, 122, 65},
        },
        {
          {36, 104, -82},
          {105, 105, 139},
          {106, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 140},
          {115, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 141},
          {115, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 142},
          {102, 122, 65},
        },
        {
          {36, 39, -9},
          {48, 48, 62},
          {49, 49, 143},
          {50, 50, 144},
          {51, 95, -41},
          {97, 122, 65},
        },
        {
        },
        {
          {0, 8, 145},
          {9, 9, 146},
          {10, 10, 147},
          {11, 12, 145},
          {13, 13, 148},
          {14, 31, 145},
          {32, 32, 149},
          {33, 34, 145},
          {35, 35, 150},
          {36, 41, 145},
          {42, 42, 151},
          {43, 46, 145},
          {47, 47, 152},
          {48, 65535, 145},
        },
        {
        },
        {
          {0, 65535, -70},
        },
        {
          {0, 41, 153},
          {42, 42, 105},
          {43, 46, 153},
          {47, 47, 154},
          {48, 65535, 153},
        },
        {
        },
        {
          {36, 39, -9},
          {48, 48, 155},
          {49, 49, 156},
          {50, 50, 157},
          {51, 95, -41},
          {97, 111, 65},
          {112, 112, 158},
          {113, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 159},
          {102, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 160},
          {116, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 161},
          {98, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 162},
          {117, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 98, -88},
          {99, 99, 163},
          {100, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 164},
          {112, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 165},
          {116, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 99, 65},
          {100, 100, 166},
          {101, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 167},
          {112, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 168},
          {116, 122, 65},
        },
        {
          {36, 107, -32},
          {108, 108, 169},
          {109, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 170},
          {102, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 171},
          {117, 122, 65},
        },
        {
          {36, 39, -9},
          {48, 48, 172},
          {49, 49, 173},
          {50, 50, 174},
          {51, 122, -102},
        },
        {
          {36, 39, -9},
          {45, 45, 175},
          {48, 122, -9},
        },
        {
          {36, 113, -43},
          {114, 114, 176},
          {115, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 104, -82},
          {105, 105, 177},
          {106, 122, 65},
        },
        {
          {36, 99, -120},
          {100, 100, 178},
          {101, 101, 65},
          {102, 102, 179},
          {103, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 180},
          {117, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 181},
          {117, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 182},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 98, -88},
          {99, 99, 183},
          {100, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 184},
          {102, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 185},
          {102, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 186},
          {102, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 187},
          {112, 117, 65},
          {118, 118, 188},
          {119, 122, 65},
        },
        {
          {36, 39, -9},
          {48, 48, 189},
          {49, 49, 190},
          {50, 50, 191},
          {51, 95, -41},
          {97, 104, 65},
          {105, 105, 192},
          {106, 122, 65},
        },
        {
          {36, 104, -82},
          {105, 105, 193},
          {106, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 194},
          {115, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 195},
          {116, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 196},
          {116, 122, 65},
        },
        {
          {0, 65535, -104},
        },
        {
          {0, 65535, -104},
        },
        {
          {0, 8, 104},
          {9, 9, 197},
          {10, 10, 147},
          {11, 12, 104},
          {13, 13, 148},
          {14, 31, 104},
          {32, 32, 198},
          {33, 34, 104},
          {35, 35, 199},
          {36, 41, 104},
          {42, 42, 105},
          {43, 46, 104},
          {47, 47, 200},
          {48, 65535, 104},
        },
        {
          {0, 65535, -149},
        },
        {
          {0, 65535, -104},
        },
        {
          {0, 65535, -104},
        },
        {
          {0, 8, 201},
          {9, 9, 202},
          {10, 10, 203},
          {11, 12, 201},
          {13, 13, 204},
          {14, 31, 201},
          {32, 32, 205},
          {33, 34, 201},
          {35, 35, 206},
          {36, 41, 201},
          {42, 42, 151},
          {43, 46, 201},
          {47, 47, 207},
          {48, 65535, 201},
        },
        {
          {0, 41, -104},
          {42, 42, 208},
          {43, 65535, -104},
        },
        {
          {0, 41, 209},
          {42, 42, 210},
          {43, 65535, 209},
        },
        {
          {9, 47, -3},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 110, -34},
          {111, 111, 211},
          {112, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 212},
          {115, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 213},
          {117, 122, 65},
        },
        {
          {36, 116, -38},
          {117, 117, 214},
          {118, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 120, 65},
          {121, 121, 215},
          {122, 122, 65},
        },
        {
          {36, 116, -38},
          {117, 117, 216},
          {118, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 217},
          {115, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 218},
          {102, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 219},
          {102, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 220},
          {115, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 221},
          {117, 122, 65},
        },
        {
          {36, 116, -38},
          {117, 117, 222},
          {118, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 223},
          {115, 122, 65},
        },
        {
          {36, 111, -79},
          {112, 112, 224},
          {113, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {115, 115, 225},
          {116, 116, 226},
        },
        {
          {36, 110, -34},
          {111, 111, 227},
          {112, 122, 65},
        },
        {
          {36, 109, -47},
          {110, 110, 228},
          {111, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 104, -82},
          {105, 105, 229},
          {106, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 230},
          {115, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 231},
          {117, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 90, -9},
          {95, 95, 232},
          {97, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 109, -47},
          {110, 110, 233},
          {111, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 234},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 95, -9},
          {97, 97, 235},
          {98, 122, 65},
        },
        {
          {36, 101, -78},
          {102, 102, 236},
          {103, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 237},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {0, 65535, -149},
        },
        {
          {0, 65535, -149},
        },
        {
          {0, 65535, -104},
        },
        {
          {0, 41, 104},
          {42, 42, 238},
          {43, 65535, 104},
        },
        {
          {0, 8, 239},
          {9, 9, 240},
          {10, 10, 241},
          {11, 12, 239},
          {13, 13, 242},
          {14, 31, 239},
          {32, 32, 243},
          {33, 34, 239},
          {35, 35, 244},
          {36, 41, 239},
          {42, 42, 245},
          {43, 46, 239},
          {47, 47, 246},
          {48, 65535, 239},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 8, 209},
          {9, 9, 247},
          {10, 10, 241},
          {11, 12, 209},
          {13, 13, 242},
          {14, 31, 209},
          {32, 32, 248},
          {33, 34, 209},
          {35, 35, 249},
          {36, 41, 209},
          {42, 42, 210},
          {43, 46, 209},
          {47, 47, 250},
          {48, 65535, 209},
        },
        {
          {0, 65535, -205},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 65535, -61},
        },
        {
          {0, 8, 251},
          {9, 9, 252},
          {10, 10, 253},
          {11, 12, 251},
          {13, 13, 254},
          {14, 31, 251},
          {32, 32, 255},
          {33, 34, 251},
          {35, 35, 256},
          {36, 41, 251},
          {42, 42, 151},
          {43, 46, 251},
          {47, 47, 257},
          {48, 65535, 251},
        },
        {
          {0, 65535, -155},
        },
        {
          {0, 41, 153},
          {42, 42, 210},
          {43, 65535, -107},
        },
        {
          {36, 114, -76},
          {115, 115, 258},
          {116, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 259},
          {117, 122, 65},
        },
        {
          {36, 90, -9},
          {95, 95, 260},
          {97, 122, 65},
        },
        {
          {36, 107, -32},
          {108, 108, 261},
          {109, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 262},
          {117, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 263},
          {117, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 264},
          {117, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 265},
          {98, 122, 65},
        },
        {
          {36, 99, -120},
          {100, 100, 266},
          {101, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 110, -34},
          {111, 111, 267},
          {112, 122, 65},
        },
        {
          {116, 116, 268},
        },
        {
          {114, 114, 269},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 95, -9},
          {97, 119, 65},
          {120, 120, 270},
          {121, 122, 65},
        },
        {
          {36, 104, -82},
          {105, 105, 271},
          {106, 122, 65},
        },
        {
          {36, 120, -164},
          {121, 121, 272},
          {122, 122, 65},
        },
        {
          {36, 113, -43},
          {114, 114, 273},
          {115, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 113, -43},
          {114, 114, 274},
          {115, 122, 65},
        },
        {
          {36, 109, -47},
          {110, 110, 275},
          {111, 122, 65},
        },
        {
          {36, 120, -164},
          {121, 121, 276},
          {122, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {0, 41, 277},
          {42, 42, 105},
          {43, 46, 277},
          {47, 47, 278},
          {48, 65535, 277},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 65535, -205},
        },
        {
          {0, 65535, -205},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 41, -153},
          {42, 42, 245},
          {43, 65535, -153},
        },
        {
          {0, 41, -203},
          {42, 42, 279},
          {43, 65535, -203},
        },
        {
          {0, 65535, -205},
        },
        {
          {0, 65535, -205},
        },
        {
          {0, 65535, -203},
        },
        {
          {0, 41, 209},
          {42, 42, 280},
          {43, 65535, 209},
        },
        {
          {0, 8, 281},
          {9, 9, 282},
          {10, 10, 283},
          {11, 12, 281},
          {13, 13, 284},
          {14, 31, 281},
          {32, 32, 285},
          {33, 34, 281},
          {35, 35, 286},
          {36, 41, 281},
          {42, 42, 287},
          {43, 46, 281},
          {47, 47, 288},
          {48, 65535, 281},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 8, 289},
          {9, 9, 290},
          {10, 10, 283},
          {11, 12, 289},
          {13, 13, 284},
          {14, 31, 289},
          {32, 32, 291},
          {33, 34, 289},
          {35, 35, 292},
          {36, 41, 289},
          {42, 42, 293},
          {43, 46, 289},
          {47, 47, 294},
          {48, 65535, 289},
        },
        {
          {0, 65535, -255},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 65535, -154},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 295},
          {117, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 296},
          {117, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 297},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 298},
          {117, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 299},
          {102, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 300},
          {116, 122, 65},
        },
        {
          {114, 114, 301},
        },
        {
          {101, 101, 302},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 98, -88},
          {99, 99, 303},
          {100, 122, 65},
        },
        {
          {36, 111, -79},
          {112, 112, 304},
          {113, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 305},
          {112, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 306},
          {116, 122, 65},
        },
        {
          {36, 115, -86},
          {116, 116, 307},
          {117, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {0, 41, 289},
          {42, 42, 293},
          {43, 65535, 289},
        },
        {
          {0, 65535, -149},
        },
        {
          {0, 41, -210},
          {42, 42, 287},
          {43, 65535, -210},
        },
        {
          {0, 41, 277},
          {42, 42, 293},
          {43, 65535, -240},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 65535, -255},
        },
        {
          {0, 65535, -255},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 41, -153},
          {42, 42, 287},
          {43, 65535, -153},
        },
        {
          {0, 41, -253},
          {42, 42, 308},
          {43, 65535, -253},
        },
        {
          {0, 65535, -279},
        },
        {
          {0, 65535, -255},
        },
        {
          {0, 65535, -255},
        },
        {
          {0, 65535, -253},
        },
        {
          {0, 41, 153},
          {42, 42, 293},
          {43, 65535, -107},
        },
        {
          {0, 41, 289},
          {42, 42, 309},
          {43, 65535, 289},
        },
        {
          {36, 113, -43},
          {114, 114, 310},
          {115, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 118, 65},
          {119, 119, 311},
          {120, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 100, -35},
          {101, 101, 312},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
        },
        {
          {101, 101, 313},
        },
        {
          {36, 115, -86},
          {116, 116, 314},
          {117, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 315},
          {102, 122, 65},
        },
        {
          {36, 110, -34},
          {111, 111, 316},
          {112, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 317},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {0, 65535, -281},
        },
        {
          {0, 65535, -282},
        },
        {
          {36, 100, -35},
          {101, 101, 318},
          {102, 122, 65},
        },
        {
          {36, 103, -49},
          {104, 104, 319},
          {105, 122, 65},
        },
        {
          {36, 90, -9},
          {95, 95, 320},
          {97, 122, 65},
        },
        {
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 115, -86},
          {116, 116, 321},
          {117, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 100, -35},
          {101, 101, 322},
          {102, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 323},
          {102, 122, 65},
        },
        {
          {36, 114, -76},
          {115, 115, 324},
          {116, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 113, -43},
          {114, 114, 325},
          {115, 122, 65},
        },
        {
          {36, 111, -79},
          {112, 112, 326},
          {113, 122, 65},
        },
        {
          {36, 100, -35},
          {101, 101, 327},
          {102, 122, 65},
        },
        {
          {36, 95, -9},
          {97, 97, 328},
          {98, 122, 65},
        },
        {
          {36, 48, -102},
          {49, 49, 329},
          {50, 50, 330},
          {51, 122, -102},
        },
        {
          {36, 98, -88},
          {99, 99, 331},
          {100, 122, 65},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 122, -9},
        },
        {
          {36, 100, -35},
          {101, 101, 332},
          {102, 122, 65},
        },
        {
          {36, 122, -9},
        },
      },
    };
    */

    private static int[][] accept; /* = {
      {
  -1, 0, 0, 0, 0, -1, 0, 85, 4, 34, 50, 54, 44, 9, 38, 13, 53, 84, 84, 8, 51, 29, 15, 20, 85, 28, 52, 48, 61, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 27, 43, 46, 40, -1, -1, 86, 0, 0, 0, 0, 0, 85, 85, 85, 85, 85, 85, 5, -1, -1, 84, 30, 23, 21, 85, 85, 85, 85, 85, 85, 85, 85, 85, 24, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 41, 0, 26, -1, -1, 7, 85, 85, 85, 85, 85, 16, 17, 18, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 36, 37, 85, 85, 85, 85, 85, 56, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 1, 2, 3, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 31, 32, 33, -1, 85, 85, 45, 85, 85, 49, 85, 78, 57, 58, 75, 85, 85, 62, 63, 64, 85, 85, 85, 79, 80, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1, 85, 85, 10, 85, 14, 85, 85, 19, 22, 85, 85, 85, 25, 85, -1, -1, 35, 42, 85, 85, 85, 85, 59, 85, 85, 85, 65, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 83, 6, 85, 85, 85, 68, 67, 85, 85, 85, -1, -1, 69, 85, 85, 85, 85, 85, 55, -1, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, -1, -1, 85, 85, 74, 85, 66, 72, 70, -1, 85, 85, 85, 85, 77, 0, -1, 85, 85, 85, 71, 47, 76, 85, 60, 85, 85, 85, 81, 82, 85, 85, 85, 85, 85, 85, 11, 12, 85, 73, 

      },
    };
    */

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
